﻿/// <reference path="../../../../typings/angularjs/angular.d.ts"/>
'use strict';

document.addEventListener('deviceready', deviceReady, false);
// document.addEventListener('DOMContentLoaded', deviceReady, false);

function deviceReady() {
    angular.bootstrap(document, ['app']);
};

angular.module('app', ['loader'])

.run(function($rootScope){
    // Hide Splash Screen
    window.navigator && window.navigator.splashscreen && window.navigator.splashscreen.hide();
    
    StatusBar.hide();
    
    document.addEventListener('offline', onOffLine, false);
    document.addEventListener('online', onOnLine, false);
    document.addEventListener('pause', onPause, false);
    // document.addEventListener('resume', onResume, false);
    
    function onOffLine() {
        // exibe mensagem informativa
        $rootScope.$apply(function() {
            $rootScope.errorMessage = "Você está desconectado";
        });
        console.log("dispositivo offline");
    };
    
    function onOnLine() {
        // remove mensagem de falta de conexao
        $rootScope.$apply(function() {
            $rootScope.errorMessage = "";
        });
        console.log("dispositivo online");
    };
    
    function onPause() {
        // talvez cancela a execução do loader e fecha a aplicacao
        console.log("aplicacao pausada");
    };
    
    function onResume() {
        // valida conexao (online/offline)
        window.location.reload();
        console.log("resume executado");
    }

})
.controller('loadCtl', function ($scope, $rootScope, $interval, loaderService) {
    var loadSync = function(){
        
        $scope.progressBar = 100;
        
        var loader = loaderService.init();
        loader.then(function (data) {
            // success
            $scope.success = JSON.stringify(data);
        }, function (error) {
            // error
            $rootScope.errorMessage = "Um erro aconteceu";
            $scope.error = JSON.stringify(error);
        }, function (data) {
            // notify
            $scope.loadProgress = data.progress;
        });
    };
    
    $scope.retryLoad = function(){
        if(!!$scope.error){
            $scope.error = "";
            $rootScope.errorMessage = "";
            loadSync();
        }
    };
    
    loadSync();
});